<template>
  <div class="flex pb-[80px] px-8">
    <div class="my-0 mx-auto py-0 max-w-[100%]">
      <swiper
        :modules="modules"
        :navigation="true"
        :slides-per-view="'auto'"
        :space-between="30"
        class="swiper-wrapper games-swiper"
        style="align-items: center"
      >
        <template v-for="TopNewType in TopNewTypes" :key="TopNewType">
          <swiper-slide class="flex flex-col items-center swiper-slide">
            <nuxt-link :to="`/games/${TopNewType.replace(' ', '')}__n__gt`">
              <div class="group w-full">
                <div class="flex flex-col items-center justify-center w-4/5">
                  <div
                    class="games-types__item-link"
                    :class="{
                      active: activeTab.includes(
                        String(TopNewType.replace(' ', ''))
                      ),
                    }"
                  >
                    <img
                      class="game-filter-icon"
                      :src="
                        handleImportImage(
                          `/black_modern_1/images/gameIcons/${TopNewType.replace(
                            ' ',
                            ''
                          ).toLowerCase()}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div
                    class="text-[11px] font-semibold whitespace-nowrap overflow-hidden uppercase"
                  >
                    {{ TopNewType }}
                  </div>
                </div>
              </div>
            </nuxt-link>
          </swiper-slide>
        </template>
        <template v-for="gameType in gameTypes" :key="gameType">
          <swiper-slide class="flex flex-col items-center swiper-slide">
            <nuxt-link :to="`/games/${gameType}__n__gt`">
              <div class="group w-full">
                <div class="flex flex-col items-center justify-center w-4/5">
                  <div
                    class="games-types__item-link"
                    :class="{ active: activeTab.includes(gameType) }"
                  >
                    <img
                      class="game-filter-icon"
                      :src="
                        handleImportImage(
                          `/black_modern_1/images/gameIcons/${gameType}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div
                    class="text-[11px] font-semibold whitespace-nowrap overflow-hidden uppercase"
                  >
                    {{ gameType }}
                  </div>
                </div>
              </div>
            </nuxt-link>
          </swiper-slide>
        </template>
        <template v-for="provider in providers" :key="provider">
          <swiper-slide class="flex flex-col items-center swiper-slide">
            <nuxt-link
              :to="
                provider.IsMaintain
                  ? ''
                  : `/games/${provider.ProviderName}__n__gp`
              "
              :class="{ 'grayscale-[1] cursor-[unset]': provider.IsMaintain }"
            >
              <div class="group w-full">
                <div class="flex flex-col items-center justify-center w-4/5">
                  <div
                    class="games-types__item-link"
                    :class="{
                      active: activeTab.includes(provider.ProviderName),
                    }"
                  >
                    <img
                      class="game-filter-icon"
                      :src="
                        handleImportImage(
                          `/black_modern_1/images/gameIcons/${provider.ProviderName.replace(
                            ' ',
                            ''
                          ).toLowerCase()}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div
                    class="text-[11px] font-semibold whitespace-nowrap overflow-hidden uppercase"
                  >
                    {{ provider.GameProviderDisplayName }}
                  </div>
                </div>
              </div>
            </nuxt-link>
          </swiper-slide>
        </template>
      </swiper>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { Navigation } from "swiper";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { useGameEntryComponent } from "@/composables/useTheme";

export default defineComponent({
  setup() {
    const { getAssetImage } = commonHelper;
    const handleImportImage = (path = "") => {
      try {
        return getAssetImage(`assets/theme${path}`);
      } catch (e) {
        return path;
      }
    };
    const TopNewTypes = ["Hot Games", "New Games", "Favorite"];
    const gameTypes = computed(
      () => store.state.gameTabProviderList.SeamlessGameGameTypeList
    );
    const { providers } = useGameEntryComponent();
    const route = useRoute();
    const activeTab = ref("HotGames");
    const setActiveTab = () => {
      if (route.name === "games" && !route.params.filter) return;
      const parts = String(route.params.filter).split("_");
      activeTab.value = parts.length > 1 ? parts[0] : parts.join();
    };
    watch(
      () => route.params,
      () => {
        setActiveTab();
      }
    );
    onMounted(() => {
      setActiveTab();
    });
    return {
      handleImportImage,
      gameTypes,
      providers,
      TopNewTypes,
      modules: [Navigation],
      activeTab,
    };
  },
});
</script>

<style lang="scss" scoped>
.swiper-slide {
  width: auto;
}
.games-types__item-link {
  display: block;
  width: 48px;
  height: 48px;
  margin-bottom: 10px;
  background-color: var(--button-bg);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 12px;
  background-repeat: no-repeat;
  background-position: center;
  -webkit-transition: background 0.4s ease-out, -webkit-box-shadow 0.4s;
  transition: background 0.4s ease-out, -webkit-box-shadow 0.4s;
  transition: background 0.4s ease-out, box-shadow 0.4s;
  transition: background 0.4s ease-out, box-shadow 0.4s, -webkit-box-shadow 0.4s;
}
.games-types__item-link.active {
  background-color: var(--primary);
}
.game-filter-icon {
  max-width: 24px;
  max-height: 24px;
  margin: 12px;
}
.games-swiper {
  :deep(.swiper-button-prev) {
    color: var(--text);
    &::after {
      font-size: 20px;
    }
  }
  :deep(.swiper-button-next) {
    color: var(--text);
    &::after {
      font-size: 20px;
    }
  }
  :deep(.swiper-wrapper) {
    padding-top: 1rem;
    padding-bottom: 1rem;
  }
  :deep(.swiper-button-next) {
    transform: translate(-50%, -29%);
    background-color: var(--background2);
    height: 100%;
    width: 50px;
    right: -25px;
  }
  :deep(.swiper-button-prev) {
    transform: translate(-50%, -29%);
    background-color: var(--background2);
    height: 100%;
    width: 50px;
    left: 24px;
  }
  :deep(
      .swiper-button-next.swiper-button-disabled,
      .swiper-button-prev.swiper-button-disabled
    ) {
    display: none;
  }
  :deep(.swiper-slide) {
    justify-content: center;
    display: flex;
  }
  :deep(.swiper-slide:first-child) {
    margin-left: 1.5rem;
  }
  :deep(.swiper-slide:last-child) {
    margin-right: 1.5rem;
  }
  :deep(.swiper-button-disabled) {
    display: none;
  }
}
</style>
